<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE sect1 PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
   "http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
  <!ENTITY % general-entities SYSTEM "../../general.ent">
  %general-entities;

  <!ENTITY freeglut-download-http
           "&sourceforge-dl;/freeglut/freeglut-&freeglut-version;.tar.gz">
  <!ENTITY freeglut-download-ftp " ">
  <!ENTITY freeglut-md5sum        "1a1c4712b3100f49f5dea22a1ad57c34">
  <!ENTITY freeglut-size          "420 KB">
  <!ENTITY freeglut-buildsize     "5.2 MB">
  <!ENTITY freeglut-time          "less than 0.1 SBU">
]>

<sect1 id="freeglut" xreflabel="Freeglut-&freeglut-version;">
  <?dbhtml filename="freeglut.html"?>


  <title>Freeglut-&freeglut-version;</title>

  <indexterm zone="freeglut">
    <primary sortas="a-Freeglut">Freeglut</primary>
  </indexterm>

  <sect2 role="package">
    <title>Introduction to Freeglut</title>

    <para>
      <application>Freeglut</application> is intended to be a 100%
      compatible, completely opensourced clone of the GLUT library.
      GLUT is a window system independent toolkit for writing OpenGL
      programs, implementing a simple windowing API, which makes
      learning about and exploring OpenGL programming very easy.
    </para>

    &lfs122_checked;

    <bridgehead renderas="sect3">Package Information</bridgehead>
    <itemizedlist spacing="compact">
      <listitem>
        <para>
          Download (HTTP): <ulink url="&freeglut-download-http;"/>
        </para>
      </listitem>
      <listitem>
        <para>
          Download (FTP): <ulink url="&freeglut-download-ftp;"/>
        </para>
      </listitem>
      <listitem>
        <para>
          Download MD5 sum: &freeglut-md5sum;
        </para>
      </listitem>
      <listitem>
        <para>
          Download size: &freeglut-size;
        </para>
      </listitem>
      <listitem>
        <para>
          Estimated disk space required: &freeglut-buildsize;
        </para>
      </listitem>
      <listitem>
        <para>
          Estimated build time: &freeglut-time;
        </para>
      </listitem>
    </itemizedlist>
<!--
    <bridgehead renderas="sect3">Additional Downloads</bridgehead>
    <itemizedlist spacing="compact">
      <listitem>
        <para>
          Required patch:
          <ulink url="&patch-root;/freeglut-&freeglut-version;-gcc10_fix-1.patch"/>
        </para>
      </listitem>
    </itemizedlist>
-->
    <bridgehead renderas="sect3">Freeglut Dependencies</bridgehead>

    <bridgehead renderas="sect4">Required</bridgehead>
    <para role="required">
      <xref linkend="cmake"/> and
      <xref linkend="mesa"/>
    </para>

    <bridgehead renderas="sect4">Recommended</bridgehead>
    <para role="recommended">
      <xref linkend="glu"/>
    </para>

  </sect2>

  <sect2 role="installation">
    <title>Installation of Freeglut</title>
<!--
    <para>
      First, fix an issue with multiple defined symbols exposed by GCC-10:
    </para>

<screen><userinput>patch -Np1 -i ../freeglut-&freeglut-version;-gcc10_fix-1.patch</userinput></screen>
-->
    <para>
      Install <application>Freeglut</application> by running the
      following commands:
    </para>

<screen><userinput>mkdir build &amp;&amp;
cd    build &amp;&amp;

cmake -D CMAKE_INSTALL_PREFIX=/usr       \
      -D CMAKE_BUILD_TYPE=Release        \
      -D FREEGLUT_BUILD_DEMOS=OFF        \
      -D FREEGLUT_BUILD_STATIC_LIBS=OFF  \
      -W no-dev .. &amp;&amp;
make</userinput></screen>

    <para>
      This package does not come with a test suite.
    </para>

    <para>
      Now, as the <systemitem class="username">root</systemitem>
      user:
    </para>

<screen role="root"><userinput>make install</userinput></screen>

  </sect2>

  <sect2 role="commands">
    <title>Command Explanations</title>

    <para>
      <parameter>-D FREEGLUT_BUILD_DEMOS=OFF</parameter>: Disable building
      optional demo programs.  Note that if you choose to build them, their
      installation must be done manually.  The demo programs are limited and
      installation is not recommended.
    </para>

    <para>
      <parameter>-D FREEGLUT_BUILD_STATIC_LIBS=OFF</parameter>:
      Do not build the static library.
    </para>

  </sect2>

  <sect2 role="content">
    <title>Contents</title>

    <segmentedlist>
      <segtitle>Installed Programs</segtitle>
      <segtitle>Installed Library</segtitle>
      <segtitle>Installed Directories</segtitle>

      <seglistitem>
        <seg>
          None
        </seg>
        <seg>
          libglut.so
        </seg>
        <seg>
          /usr/lib/cmake/FreeGLUT
        </seg>
      </seglistitem>
    </segmentedlist>

    <variablelist>
      <bridgehead renderas="sect3">Short Descriptions</bridgehead>
      <?dbfo list-presentation="list"?>
      <?dbhtml list-presentation="table"?>

      <varlistentry id="libglut">
        <term><filename class="libraryfile">libglut.so</filename></term>
        <listitem>
          <para>
            contains functions that implement the OpenGL Utility
            Toolkit
          </para>
          <indexterm zone="freeglut libglut">
            <primary sortas="c-libglut">libglut.so</primary>
          </indexterm>
        </listitem>
      </varlistentry>

    </variablelist>

  </sect2>

</sect1>
